m=csvread('gw.csv',1,1);
y=m(2:end,14);
pn=13;
x=m(1:end-1,1:pn);
xf=m(:,1:pn);
bigt=length(y);
my=mean(y);
y=y-my;
for i=1:pn; x(:,i)=x(:,i)-mean(x(:,i)); xf(:,i)=xf(:,i)-mean(xf(:,i)); end;
%--------------------------%
all=1;    %0 for models with 1 predictor only; otherwise 1
n=1000;   %Discretization for asymptotic distribution
nba=50;   %Bootstrap aggregation draws
tpi=round(bigt*0.5); npi=round(n*0.5);
if all==0; amat=eye(pn); end;
if all==1;
    amat=eye(pn);
    for j=2:pn;
        cg=int8(nchoosek(1:pn,j));
        for i=1:size(cg,1);
            amat=[amat;zeros(1,pn)];
            amat(end,cg(i,:))=1;
        end;
    end;
end;
        
L=size(amat,1);
%--------------------------%
res=y-(x*inv(x'*x)*x'*y);
lambda=nw(x.*kron(res,ones(1,pn)),0);
sigma=(x'*x)/bigt;
lambda=lambda/(mean(y.^2)^2); sigma=sigma/mean(y.^2);
capy=sqrt(bigt)*sigma*inv(x'*x)*x'*y;
%-------------MLE &JS------%
bhat=inv(x'*x)*x'*y;
xlswrite('results.xlsx',bhat,'Sheet1','B3');
xlswrite('results.xlsx',my+(xf*bhat),'Sheet1','B17');
res=y-(x*bhat);
bhat=bhat*max(1-((length(bhat)-2)*mean(res.^2)/(bhat'*x'*x*bhat)),0);
xlswrite('results.xlsx',bhat,'Sheet1','C3');
xlswrite('results.xlsx',my+(xf*bhat),'Sheet1','C17');
%--------------AIC---------%
aic(1,1)=-log(mean(y.^2));
for j=1:L;
    a=find(amat(j,:)==1);
    xn=x(:,a);
    res=y-(xn*inv(xn'*xn)*xn'*y);
    aic(j+1,1)=-log(mean(res.^2))-(2*j/bigt);
end;
[qw1,qw2]=max(aic);
qw2=qw2-1;
bhat=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=x(:,a); bhat(a)=inv(xn'*xn)*xn'*y; end; 
xlswrite('results.xlsx',qw2,'Sheet1','D2');
xlswrite('results.xlsx',bhat,'Sheet1','D3');
xlswrite('results.xlsx',my+(xf*bhat),'Sheet1','D17');
clear aic res
%------Out-of-sample------%
for t=tpi:bigt-1;
    yt=y(1:t); xt=x(1:t,:);
    res(t-tpi+1,1)=y(t+1);
    for j=1:L;
        a=find(amat(j,:)==1);
        xn=xt(:,a);
        res(t-tpi+1,j+1)=y(t+1)-(x(t+1,a)*inv(xn'*xn)*xn'*yt);
    end;
end;
[qw1,qw2]=min(mean(res.^2));
qw2=qw2-1;
bhat=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=x(:,a); bhat(a)=inv(xn'*xn)*xn'*y; end; 
xlswrite('results.xlsx',qw2,'Sheet1','E2');
xlswrite('results.xlsx',bhat,'Sheet1','E3');
xlswrite('results.xlsx',my+(xf*bhat),'Sheet1','E17');
clear res
%--------Split Sample-----%
yt=y(1:tpi); xt=x(1:tpi,:);
aic(1,1)=-log(mean(yt.^2));
for j=1:L;
    a=find(amat(j,:)==1);
    xn=xt(:,a);
    res=yt-(xn*inv(xn'*xn)*xn'*yt);
    aic(j+1,1)=-log(mean(res.^2))-(2*j/(0.5*bigt)); 
end;
[qw1,qw2]=max(aic);
qw2=qw2-1;
bhat=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=x(tpi+1:end,a); bhat(a)=inv(xn'*xn)*xn'*y(tpi+1:end); end; 
xlswrite('results.xlsx',qw2,'Sheet1','F2');
xlswrite('results.xlsx',bhat,'Sheet1','F3');
xlswrite('results.xlsx',my+(xf*bhat),'Sheet1','F17');
clear res aic
%--------Bagging-AIC---------%
rand('seed',123);
for jmc=1:nba; bdraw(:,jmc)=ceil(bigt*rand(bigt,1)); end;
for jmc=1:nba;
    xboot=x(bdraw(:,jmc),:);
    yboot=y(bdraw(:,jmc));
    aic(1,1)=-log(mean(yboot.^2));
    for j=1:L;
        a=find(amat(j,:)==1);
        xn=xboot(:,a);
        res=y-(xn*inv(xn'*xn)*xn'*y);
        aic(j+1,1)=-log(mean(res.^2))-(2*j/bigt);
    end;
    [qw1,qw2]=max(aic);
    qw2=qw2-1;
    uba1(jmc)=qw2;
    bhat1(:,jmc)=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=xboot(:,a); bhat1(a,jmc)=inv(xn'*xn)*xn'*yboot; end; 
    clear aic res
%------Out-of-sample------%
    for t=tpi:bigt-1;
        yt=yboot(1:t); xt=xboot(1:t,:);
        res(t-tpi+1,1)=yboot(t+1);
        for j=1:L;
            a=find(amat(j,:)==1);
            xn=xt(:,a);
            res(t-tpi+1,j+1)=yboot(t+1)-(xboot(t+1,a)*inv(xn'*xn)*xn'*yt);
        end;
    end;
    [qw1,qw2]=min(mean(res.^2));
    qw2=qw2-1;
    uba2(jmc)=qw2;
    bhat2(:,jmc)=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=xboot(:,a); bhat2(a,jmc)=inv(xn'*xn)*xn'*yboot; end; 
    clear res
%--------Split Sample-----%
    yt=yboot(1:tpi); xt=xboot(1:tpi,:);
    aic(1,1)=-log(mean(yt.^2));
    for j=1:L;
        a=find(amat(j,:)==1);
        xn=xt(:,a);
        res=yt-(xn*inv(xn'*xn)*xn'*yt);
        aic(j+1,1)=-log(mean(res.^2))-(2*j/(0.5*bigt)); 
    end;
    [qw1,qw2]=max(aic);
    qw2=qw2-1;
    uba3(jmc)=qw2;
    bhat3(:,jmc)=zeros(pn,1); if qw2>=1; a=find(amat(qw2,:)==1); xn=xboot(tpi+1:end,a); bhat3(a,jmc)=inv(xn'*xn)*xn'*yboot(tpi+1:end); end; 
    clear res aic
end;
%----Rao Blackwellization--%
%--Brownian bridge draws---%
randn('seed',123);
rvec=[1/n:1/n:1]';
for jmc=1:nba;
    ub=cumsum(randn(n,pn)/sqrt(n))*chol(lambda);
    ub=ub-(rvec*ub(n,:));
    ubs(:,:,jmc)=ub;
end;
%--------------------------%
for jmc=1:nba;
    ub=squeeze(ubs(:,:,jmc));
    Y=(rvec*capy')+ub;
    Ypi=Y(npi,:)'; Y1=Y(n,:)';
    oosc(1,1)=0;
    for j=1:L;
        a=find(amat(j,:)==1);
        Hm=zeros(pn,pn); Hm(a,a)=inv(sigma(a,a));
        oosc(j+1,1)=(Y1'*Hm*Y1)-(Ypi'*Hm*Ypi/0.5)+(sum(diag(Hm*lambda))*log(0.5));
    end;
    [qw1,qw2]=max(oosc);
    qw2=qw2-1;
    uba4(jmc)=qw2;
    if qw2==0; 
        bhat4(:,jmc)=zeros(pn,1); 
    else; 
        a=find(amat(qw2,:)==1); 
        Hm=zeros(pn,pn); Hm(a,a)=inv(sigma(a,a));
        bhat4(:,jmc)=Hm*Y1/sqrt(bigt);
    end;
    aic(1,1)=0;
    for j=1:L;
        a=find(amat(j,:)==1);
        Hm=zeros(pn,pn); Hm(a,a)=inv(sigma(a,a));
        aic(j+1,1)=(Ypi'*Hm*Ypi/0.5)-(2*j); 
    end;
    [qw1,qw2]=max(aic);
    qw2=qw2-1;
    uba5(jmc)=qw2;
    if qw2==0; 
        bhat5(:,jmc)=zeros(pn,1); 
    else; 
        a=find(amat(qw2,:)==1); 
        Hm=zeros(pn,pn); Hm(a,a)=inv(sigma(a,a));
        bhat5(:,jmc)=Hm*(Y1-Ypi)/(0.5*sqrt(bigt));
    end;
    clear oosc aic
end;
for i=1:L+1; vba1(i,1)=mean(uba1==i-1); vba2(i,1)=mean(uba2==i-1); vba3(i,1)=mean(uba3==i-1); vba4(i,1)=mean(uba4==i-1); vba5(i,1)=mean(uba5==i-1); end;
xlswrite('results.xlsx',mean(bhat1')','Sheet1','I3');
xlswrite('results.xlsx',mean(bhat2')','Sheet1','J3');
xlswrite('results.xlsx',mean(bhat3')','Sheet1','K3');
xlswrite('results.xlsx',mean(bhat4')','Sheet1','L3');
xlswrite('results.xlsx',mean(bhat5')','Sheet1','M3');
xlswrite('results.xlsx',my+(xf*mean(bhat1')'),'Sheet1','B17');
xlswrite('results.xlsx',my+(xf*mean(bhat2')'),'Sheet1','C17');
xlswrite('results.xlsx',my+(xf*mean(bhat3')'),'Sheet1','D17');
xlswrite('results.xlsx',my+(xf*mean(bhat4')'),'Sheet1','E17');
xlswrite('results.xlsx',my+(xf*mean(bhat5')'),'Sheet1','R17');
xlswrite('results.xlsx',my,'Sheet1','B106');
xlswrite('results.xlsx',vba1,'Sheet1','P2');
xlswrite('results.xlsx',vba2,'Sheet1','Q2');
xlswrite('results.xlsx',vba3,'Sheet1','R2');
xlswrite('results.xlsx',vba4,'Sheet1','S2');
xlswrite('results.xlsx',vba5,'Sheet1','T2');
if all==1; xlswrite('results.xlsx',amat,'Sheet1','U3'); end;
