clear
close all
cd save
load Keq1
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(1)
subplot(2,2,1);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,6),'k-.','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','Bayes','OOS','Split Sample','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,11),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq3
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(2);
subplot(2,2,1);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,6),'k-.','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','Bayes','OOS','Split Sample','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,11),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq20
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(3);
subplot(2,2,1);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,6),'k-.','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','Bayes','OOS','Split Sample','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,11),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Kcombine
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(4);
subplot(2,2,1);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,4),'k--','Linewidth',2);
plot(bvec,statla(:,5),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'Exponential AIC Weights','Exponential OOS Weights','Exponential Split Sample Weights','MLE (No Combination)'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,7),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,10),'k--','Linewidth',2);
plot(bvec,statla(:,11),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=1;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc1
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(5);
subplot(2,2,1);
plot(bvec,stat(:,3),'k-','Linewidth',2);
hold on
plot(bvec,stat(:,7),'k-.','Linewidth',2);
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','Bayes','OOS','Split Sample','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,12),'k-','Linewidth',2);
hold on;
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,3),'k-','Linewidth',2);
hold on;
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq1
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(6)
subplot(2,2,1);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,4),'r--','Linewidth',2);
plot(bvec,statla(:,5),'r:','Linewidth',2);
plot(bvec,statla(:,6),'b-','Linewidth',2);
plot(bvec,statla(:,7),'b--','Linewidth',2);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','OOS','Split Sample','MLE','Laplace','LASSO','Bayes','Bayes: Tight Prior'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,11),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,12),'r--','Linewidth',2);
plot(bvec,statla(:,13),'r:','Linewidth',2);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,3),'k-','Linewidth',2);
hold on;
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq3
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(7);
subplot(2,2,1);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,4),'r--','Linewidth',2);
plot(bvec,statla(:,5),'r:','Linewidth',2);
plot(bvec,statla(:,6),'b-','Linewidth',2);
plot(bvec,statla(:,7),'b--','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','MLE','Laplace','LASSO','Bayes','Bayes: Tight Prior'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,10),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,11),'k-','Linewidth',2);
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,12),'r--','Linewidth',2);
plot(bvec,statla(:,13),'r:','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq20
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(8);
subplot(2,2,1);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,4),'r--','Linewidth',2);
plot(bvec,statla(:,5),'r:','Linewidth',2);
plot(bvec,statla(:,6),'b-','Linewidth',2);
plot(bvec,statla(:,7),'b--','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','MLE','Laplace','LASSO','Bayes','Bayes: Tight Prior'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,10),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,11),'k-','Linewidth',2);
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,12),'r--','Linewidth',2);
plot(bvec,statla(:,13),'r:','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq3_alt
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(9);
subplot(2,2,1);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,4),'r--','Linewidth',2);
plot(bvec,statla(:,5),'r:','Linewidth',2);
plot(bvec,statla(:,6),'b-','Linewidth',2);
plot(bvec,statla(:,7),'b--','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','MLE','Laplace','LASSO','Bayes','Bayes: Tight Prior'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,10),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,11),'k-','Linewidth',2);
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,12),'r--','Linewidth',2);
plot(bvec,statla(:,13),'r:','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
load Keq20_alt
ymin=min(min(statla))-0.1;
ymax=max(max(statla))+0.1;
figure(10);
subplot(2,2,1);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,8),'k--','Linewidth',2);
plot(bvec,statla(:,9),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,4),'r--','Linewidth',2);
plot(bvec,statla(:,5),'r:','Linewidth',2);
plot(bvec,statla(:,6),'b-','Linewidth',2);
plot(bvec,statla(:,7),'b--','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','MLE','Laplace','LASSO','Bayes','Bayes: Tight Prior'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,statla(:,10),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,11),'k-','Linewidth',2);
plot(bvec,statla(:,14),'k--','Linewidth',2);
plot(bvec,statla(:,15),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
plot(bvec,statla(:,12),'r--','Linewidth',2);
plot(bvec,statla(:,13),'r:','Linewidth',2);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,statla(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,statla(:,3),'k-','Linewidth',2);
plot(bvec,statla(:,16),'k--','Linewidth',2);
plot(bvec,statla(:,17),'k:','Linewidth',2);
plot(bvec,statla(:,1),'k-','Linewidth',0.5);
xlabel('b_1','Fontsize',12)
axis([0 6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=1;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc1
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(11);
subplot(2,2,1);
plot(bvec,stat(:,3),'k-','Linewidth',2);
hold on
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,4),'r-','Linewidth',2);
plot(bvec,stat(:,5),'r--','Linewidth',2);
plot(bvec,stat(:,8),'r:','Linewidth',2);
plot(bvec,stat(:,6),'b-','Linewidth',2);
plot(bvec,stat(:,7),'b--','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'AIC','OOS','Split Sample','LASSO','Laplace','CV','Bayes','Bayes: Tight Prior','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,12),'k-','Linewidth',2);
hold on
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,13),'r-','Linewidth',2);
plot(bvec,stat(:,14),'r--','Linewidth',2);
plot(bvec,stat(:,15),'r:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,3),'k-','Linewidth',2);
hold on; 
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=3;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc3
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(12);
subplot(2,2,1);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,4),'r-','Linewidth',2);
plot(bvec,stat(:,5),'r--','Linewidth',2);
plot(bvec,stat(:,8),'r:','Linewidth',2);
plot(bvec,stat(:,6),'b-','Linewidth',2);
plot(bvec,stat(:,7),'b--','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','LASSO','Laplace','CV','Bayes','Bayes: Tight Prior','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,11),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,12),'k-','Linewidth',2);
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,13),'r-','Linewidth',2);
plot(bvec,stat(:,14),'r--','Linewidth',2);
plot(bvec,stat(:,15),'r:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on;
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=20;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc20
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(13);
subplot(2,2,1);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,4),'r-','Linewidth',2);
plot(bvec,stat(:,5),'r--','Linewidth',2);
plot(bvec,stat(:,8),'r:','Linewidth',2);
plot(bvec,stat(:,6),'b-','Linewidth',2);
plot(bvec,stat(:,7),'b--','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','LASSO','Laplace','CV','Bayes','Bayes: Tight Prior','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,11),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,12),'k-','Linewidth',2);
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,13),'r-','Linewidth',2);
plot(bvec,stat(:,14),'r--','Linewidth',2);
plot(bvec,stat(:,15),'r:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on;
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=3;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc3_alt
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(14);
subplot(2,2,1);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,4),'r-','Linewidth',2);
plot(bvec,stat(:,5),'r--','Linewidth',2);
plot(bvec,stat(:,8),'r:','Linewidth',2);
plot(bvec,stat(:,6),'b-','Linewidth',2);
plot(bvec,stat(:,7),'b--','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','LASSO','Laplace','CV','Bayes','Bayes: Tight Prior','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,11),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,12),'k-','Linewidth',2);
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,13),'r-','Linewidth',2);
plot(bvec,stat(:,14),'r--','Linewidth',2);
plot(bvec,stat(:,15),'r:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on;
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
K=20;
bvec=[0;0.05;0.1;0.15;0.2;0.3;0.4;0.5];
bvec=[bvec;[0.6:0.2:6]'];
bvec=bvec/sqrt(100);
load statmc20_alt
ymin=min(min(stat(:,1:13)))-0.1;
ymax=max(max(stat(:,1:13)))+0.1;
figure(15);
subplot(2,2,1);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,9),'k--','Linewidth',2);
plot(bvec,stat(:,10),'k:','Linewidth',2);
plot(bvec,stat(:,4),'r-','Linewidth',2);
plot(bvec,stat(:,5),'r--','Linewidth',2);
plot(bvec,stat(:,8),'r:','Linewidth',2);
plot(bvec,stat(:,6),'b-','Linewidth',2);
plot(bvec,stat(:,7),'b--','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('No resampling','Fontsize',12);
legend({'James Stein','AIC','OOS','Split Sample','LASSO','Laplace','CV','Bayes','Bayes: Tight Prior','MLE'},'Position',[0.63,0.19,0.2,0.2]);
legend('boxoff');
subplot(2,2,2);
plot(bvec,stat(:,11),'k-.','Linewidth',2);
hold on
plot(bvec,stat(:,12),'k-','Linewidth',2);
plot(bvec,stat(:,16),'k--','Linewidth',2);
plot(bvec,stat(:,17),'k:','Linewidth',2);
plot(bvec,stat(:,13),'r-','Linewidth',2);
plot(bvec,stat(:,14),'r--','Linewidth',2);
plot(bvec,stat(:,15),'r:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Bagging','Fontsize',12);
subplot(2,2,3);
plot(bvec,stat(:,2),'k-.','Linewidth',2);
hold on;
plot(bvec,stat(:,3),'k-','Linewidth',2);
plot(bvec,stat(:,18),'k--','Linewidth',2);
plot(bvec,stat(:,19),'k:','Linewidth',2);
plot(bvec,stat(:,1),'k-','Linewidth',0.5);
xlabel('\beta_1','Fontsize',12)
axis([0 0.6 ymin ymax]);
title('Rao-Blackwellization','Fontsize',12);
clear
%----------------------------------------------%
cd ..



