function stat = oossb(b,pi);
%Output is 14x1 consisting of:
%OLS/JS/AIC/CV/OOS/SS/JSB/AICB/OOSB/SSB/OOSRB/SSRB/OOSRB2/SSRB2
K=1;
randn('seed',123); rand('seed',123);
model=2;    
replics=1000;
bigt=100;
bigt=round(round(bigt*min(pi,1-pi))/min(pi,1-pi));
tpi=round(pi*bigt);
L=round(1/min(pi,1-pi));
nba=50;
for imc=1:replics;
    x=randn(bigt+1,K);
    %beta=zeros(bigt+1,K);
    beta=b*cumsum(randn(bigt+1,K));
    fbeta=beta(end,:)';  %Final value of beta
    y=((x.*beta)*ones(K,1))+(trnd(5,bigt+1,1)/sqrt(5/3));
    %y=(x*beta)+randn(bigt+1,1);
    xt=x(1:bigt,:); yt=y(1:bigt);
    indx=1;
    bhat(:,indx)=zeros(K,1);
    aic(indx,1)=log(mean(yt.^2));
    for j=1:K;
        if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
        for i=1:size(a,1);
            indx=indx+1;
            bhat(a(i,:),indx)=inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt;
            res = yt-(xt*bhat(:,indx));
            aic(indx,1)=log(mean(res.^2))+(2*j/bigt);
        end;
    end;
    [qw1,qw2]=min(aic);
    forc(imc,1)=(fbeta-bhat(:,end))'*(fbeta-bhat(:,end));
    if K<=2; 
        forc(imc,2)=forc(imc,1);
    else;
        jsb=bhat(:,end)*max(1-((K-2)*mean(res.^2)/(bhat(:,end)'*xt'*xt*bhat(:,end))),0);
        forc(imc,2)=(fbeta-jsb)'*(fbeta-jsb);
    end;
    forc(imc,3)=(fbeta-bhat(:,qw2))'*(fbeta-bhat(:,qw2));
    clear bhat res aic indx
%------------------------------------------------%
    for t=1:bigt;
        xt=x(1:bigt,:); yt=y(1:bigt);
        xt=[xt(1:t-1,:);xt(t+1:end,:)]; yt=[yt(1:t-1);yt(t+1:end)];
        indx=1;
        bhat(:,indx)=zeros(K,1);
        res(t,1)=y(t);
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
            for i=1:size(a,1);
                indx=indx+1;
                res(t,indx) = y(t)-(x(t,a(i,:))*inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt);
                bhat(a(i,:),indx)=inv(x(1:bigt,a(i,:))'*x(1:bigt,a(i,:)))*x(1:bigt,a(i,:))'*y(1:bigt);
            end;    
        end;
    end;
    [qw1,qw2]=min(mean(res.^2));
    forc(imc,4)=(fbeta-bhat(:,qw2))'*(fbeta-bhat(:,qw2));
    clear bhat res indx
%------------------------------------------------%
    for t=tpi:bigt-1
        xt=x(1:t,:); yt=y(1:t);
        indx=1;
        bhat(:,indx)=zeros(K,1);
        res(t-tpi+1,1)=y(t+1);
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
            for i=1:size(a,1);
                indx=indx+1;
                bhat(a(i,:),indx) = inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt;
                res(t-tpi+1,indx) = y(t+1)-(x(t+1,:)*bhat(:,indx));
            end;
        end;
    end;
    [qw1,qw2]=min(mean(res.^2));
    forc(imc,5)=(fbeta-bhat(:,qw2))'*(fbeta-bhat(:,qw2));
    clear bhat res indx
%------------------------------------------------%
    xt=x(1:tpi,:); yt=y(1:tpi);
    indx=1;
    aic(indx,1)=log(mean(yt.^2));
    bhat(:,indx)=zeros(K,1);
    for j=1:K;
        if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
        for i=1:size(a,1);
            indx=indx+1;
            res = yt-(xt(:,a(i,:))*inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt);
            aic(indx,1)=log(mean(res.^2))+(2*j/length(res));
            bhat(a(i,:),indx)=inv(x(tpi+1:bigt,a(i,:))'*x(tpi+1:bigt,a(i,:)))*x(tpi+1:bigt,a(i,:))'*y(tpi+1:bigt);
        end;
    end;
    [qw1,qw2]=min(aic);
    bhatn1=bhat(:,qw2);
    forc(imc,6)=(fbeta-bhatn1)'*(fbeta-bhatn1);
    clear bhat res aic indx
%------------------------------------------------%
%------------------------------------------------%
    for jmc=1:nba;
        bdraw=[ceil(bigt*rand(bigt,1));bigt+1];
        xboot=x(bdraw,:);
        yboot=y(bdraw);
        xt=xboot(1:bigt,:); yt=yboot(1:bigt);
        indx=1;
        bhat(:,indx)=zeros(K,1);
        aic(indx,1)=log(mean(yt.^2));
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
            for i=1:size(a,1);
                indx=indx+1;
                bhat(a(i,:),indx)=inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt;
                res = yt-(xt*bhat(:,indx));
                aic(indx,1)=log(mean(res.^2))+(2*j/bigt);
            end;
        end;
        [qw1,qw2]=min(aic);
        fba1(:,jmc)=bhat(:,qw2);
        clear bhat res aic indx
%------------------------------------------------%
        for t=1:bigt;
            xt=xboot(1:bigt,:); yt=yboot(1:bigt);
            xt=[xt(1:t-1,:);xt(t+1:end,:)]; yt=[yt(1:t-1);yt(t+1:end)];
            indx=1;
            bhat(:,indx)=zeros(K,1);
            res(t,1)=yboot(t);
            for j=1:K;
                if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
                for i=1:size(a,1);
                    indx=indx+1;
                    res(t,indx) = yboot(t)-(xboot(t,a(i,:))*inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt);
                    bhat(a(i,:),indx)=inv(xboot(1:bigt,a(i,:))'*xboot(1:bigt,a(i,:)))*xboot(1:bigt,a(i,:))'*yboot(1:bigt);
                end;    
            end;
        end;
        [qw1,qw2]=min(mean(res.^2));
        fba2(:,jmc)=bhat(:,qw2);
        clear bhat res indx
%------------------------------------------------%
        for t=tpi:bigt-1
            xt=xboot(1:t,:); yt=yboot(1:t);
            indx=1;
            bhat(:,indx)=zeros(K,1);
            res(t-tpi+1,1)=yboot(t+1);
            for j=1:K;
                if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
                for i=1:size(a,1);
                    indx=indx+1;
                    bhat(a(i,:),indx) = inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt;
                    res(t-tpi+1,indx) = yboot(t+1)-(xboot(t+1,:)*bhat(:,indx));
                end;
            end;
        end;
        [qw1,qw2]=min(mean(res.^2));
        fba3(:,jmc)=bhat(:,qw2);
        clear bhat res indx
%------------------------------------------------%
        xt=xboot(1:tpi,:); yt=yboot(1:tpi);
        indx=1;
        res=yt;
        aic(indx,1)=log(mean(res.^2));
        bhat(:,indx)=zeros(K,1);
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
            for i=1:size(a,1);
                indx=indx+1;
                res = yt-(xt(:,a(i,:))*inv(xt(:,a(i,:))'*xt(:,a(i,:)))*xt(:,a(i,:))'*yt);
                aic(indx,1)=log(mean(res.^2))+(2*j/length(res));
                bhat(a(i,:),indx)=inv(xboot(tpi+1:bigt,a(i,:))'*xboot(tpi+1:bigt,a(i,:)))*xboot(tpi+1:bigt,a(i,:))'*yboot(tpi+1:bigt);
            end;
        end;
        [qw1,qw2]=min(aic);
        fba4(:,jmc)=bhat(:,qw2);
        clear bhat res aic indx
%------------------------------------------------%
%------------------------------------------------%
        xt=x(1:bigt,:); yt=y(1:bigt);
        theta=(2*(rand(bigt,1)>0.5))-1;
        bols=inv(xt'*xt)*xt'*yt; res=yt-(xt*bols); res=res.*theta;  %Alternative bagging
        zboot=xt.*kron(xt*bols,ones(1,K));
        xres=xt.*kron(res,ones(1,K));
        zboot=zboot+xres-kron(ones(bigt,1),mean(xres));
        clear res xres
        for t=tpi:bigt-1
            xt=x(1:t,:); zt=zboot(1:t,:);
            indx=1;
            bhat(:,indx)=zeros(K,1);
            ressq(t-tpi+1,1)=0;
            for j=1:K;
                if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
                for i=1:size(a,1);
                    indx=indx+1;
                    bhat(a(i,:),indx) = inv(xt(:,a(i,:))'*xt(:,a(i,:)))*sum(zt(:,a(i,:)))';
                    ressq(t-tpi+1,indx) = ((x(t+1,:)*bhat(:,indx))^2)-(2*zboot(t+1,:)*bhat(:,indx));
                end;
            end;
        end;
        [qw1,qw2]=min(mean(ressq));
        gba1(:,jmc)=bhat(:,qw2);
        clear bhat ressq indx
%------------------------------------------------%
        xt=x(1:tpi,:); zt=zboot(1:tpi,:);
        indx=1;
        aic(indx,1)=log(mean(y(1:tpi).^2));
        bhat(:,indx)=zeros(K,1);
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;       
            for i=1:size(a,1);
                indx=indx+1;
                bai=inv(xt(:,a(i,:))'*xt(:,a(i,:)))*sum(zt(:,a(i,:)))';
                ressq = (y(1:tpi).^2)+((xt(:,a(i,:))*bai).^2)-(2*zt(:,a(i,:))*bai);
                aic(indx,1)=log(mean(ressq))+(2*j/length(ressq));
                bhat(a(i,:),indx)=inv(x(tpi+1:bigt,a(i,:))'*x(tpi+1:bigt,a(i,:)))*sum(zboot(tpi+1:bigt,a(i,:)))';
            end;
        end;
        [qw1,qw2]=min(aic);
        gba2(:,jmc)=bhat(:,qw2);
        clear bhat ressq aic indx
%------------------------------------------------%
%------------------------------------------------%
        xt=x(1:bigt,:); yt=y(1:bigt);
        rvec=[1/bigt:1/bigt:1]';
        ub=cumsum(randn(bigt,K)/sqrt(bigt));
        ub=ub-(rvec*ub(bigt,:));
        Yp=(sqrt(bigt)*rvec*yt'*xt*inv(xt'*xt))+ub;
        indx=1;
        v(:,indx)=zeros(K,1); s(indx,1)=0; 
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                yz=zeros(K,1); yzpi=zeros(K,1); yz(a(i,:))=Yp(bigt,a(i,:))';  yzpi(a(i,:))=Yp(tpi,a(i,:))';
                v(:,indx)=yz;
                s(indx,1)=(yz'*yz)-(yzpi'*yzpi/pi)+(j*log(pi));
            end;
        end;
        [qw1,qw2]=max(s);
        hba1(:,jmc)=v(:,qw2);
        clear v s
%------------------------------------------------%
        indx=1;
        v(:,indx)=zeros(K,1); aic(indx,1)=0;
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                c1=a(i,:); 
                yz=zeros(K,1); yz(c1)=Yp(tpi,c1)';
                yzz=zeros(K,1); yzz(c1)=(Yp(bigt,c1)-Yp(tpi,c1))'/(1-pi);           
                v(:,indx)=yzz;
                aic(indx,1)=(yz'*yz/pi)-(2*j);
            end;
        end;
        [qw1,qw2]=max(aic);
        hba2(:,jmc)=v(:,qw2);
        clear v aic
    end;
%------------------------------------------------%
%------------------------------------------------%
    fba1=mean(fba1')'; fba2=mean(fba2')'; fba3=mean(fba3')'; fba4=mean(fba4')'; 
    gba1=mean(gba1')'; gba2=mean(gba2')'; 
    hba1=mean(hba1')'/sqrt(bigt); hba2=mean(hba2')'/sqrt(bigt); 
     forc(imc,7)=(fbeta-fba1)'*(fbeta-fba1);
    forc(imc,8)=(fbeta-fba2)'*(fbeta-fba2);
    forc(imc,9)=(fbeta-fba3)'*(fbeta-fba3);
    forc(imc,10)=(fbeta-fba4)'*(fbeta-fba4);
    forc(imc,11)=(fbeta-gba1)'*(fbeta-gba1);
    forc(imc,12)=(fbeta-gba2)'*(fbeta-gba2);
    forc(imc,13)=(fbeta-hba1)'*(fbeta-hba1);
    forc(imc,14)=(fbeta-hba2)'*(fbeta-hba2);
%------------------------------------------------%
imc
end;
stat=sqrt(bigt)*sqrt(mean(forc));